# class Gem::PathSupport

`Gem::PathSupport` facilitates the GEM_HOME and GEM_PATH environment settings to the rest of RubyGems.

### Attributes

home [R]

The default system path for managing Gems.

path [R]

`Array` of paths to search for Gems.

### Public Class Methods

new (env)
Source

    # File lib/rubygems/path_support.rb, line 26
    def initialize(env)
      @home = normalize_home_dir(env["GEM_HOME"] || Gem.default_dir)
      @path = split_gem_path env["GEM_PATH"], @home

      @spec_cache_dir = env["GEM_SPEC_CACHE"] || Gem.default_spec_cache_dir
    end

Constructor. Takes a single argument which is to be treated like a hashtable, or defaults to `ENV`, the system environment.

### Private Instance Methods

default_path ()
Source

    # File lib/rubygems/path_support.rb, line 74
    def default_path
      Gem.default_path + [@home]
    end

Return the default `Gem` path

expand (path)
Source

    # File lib/rubygems/path_support.rb, line 78
    def expand(path)
      if File.directory?(path)
        File.realpath(path)
      else
        path
      end
    end

normalize_home_dir (home)
Source

    # File lib/rubygems/path_support.rb, line 35
    def normalize_home_dir(home)
      if File::ALT_SEPARATOR
        home = home.gsub(File::ALT_SEPARATOR, File::SEPARATOR)
      end

      expand(home)
    end

split_gem_path (gpaths, home)
Source

    # File lib/rubygems/path_support.rb, line 46
    def split_gem_path(gpaths, home)
      # FIX: it should be [home, *path], not [*path, home]

      gem_path = []

      if gpaths
        gem_path = gpaths.split(Gem.path_separator)
        # Handle the path_separator being set to a regexp, which will cause
        # end_with? to error
        if /#{Gem.path_separator}\z/.match?(gpaths)
          gem_path += default_path
        end

        if File::ALT_SEPARATOR
          gem_path.map! do |this_path|
            this_path.gsub File::ALT_SEPARATOR, File::SEPARATOR
          end
        end

        gem_path << home
      else
        gem_path = default_path
      end

      gem_path.map {|path| expand(path) }.uniq
    end

Split the `Gem` search path (as reported by `Gem.path`).